"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadImagepicker = void 0;
var rad_imagepicker_common_1 = require("./rad-imagepicker.common");
var app = require("tns-core-modules/application");
var frame = require("tns-core-modules/ui/frame");
var permissions = require("nativescript-permissions");
var imageSource = require("tns-core-modules/image-source");
var Pix = com.fxn.pix.Pix;
var RadImagepicker = (function (_super) {
    __extends(RadImagepicker, _super);
    function RadImagepicker() {
        return _super.call(this) || this;
    }
    RadImagepicker.prototype.authorize = function () {
        if (android.os.Build.VERSION.SDK_INT >= 23) {
            return permissions.requestPermission([
                android.Manifest.permission.READ_EXTERNAL_STORAGE,
                android.Manifest.permission.WRITE_EXTERNAL_STORAGE,
                android.Manifest.permission.CAMERA
            ]);
        }
        else {
            return Promise.resolve();
        }
    };
    RadImagepicker.prototype.pick = function (options) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.authorize()
                .then(function () {
                var onResult = function (args) {
                    var requestCode = args.requestCode;
                    var resultCode = args.resultCode;
                    var data = args.intent;
                    switch (requestCode) {
                        case (100):
                            {
                                if (resultCode == android.app.Activity.RESULT_OK) {
                                    var returnValue = data.getStringArrayListExtra(Pix.IMAGE_RESULTS);
                                    var imgArray = returnValue.toArray();
                                    var images = [];
                                    for (var i_1 = 0; i_1 < imgArray.length; i_1++) {
                                        images.push(imageSource.fromFile(imgArray[i_1].toString()));
                                    }
                                    resolve(images);
                                }
                                else if (resultCode == android.app.Activity.RESULT_CANCELED) {
                                    resolve();
                                }
                            }
                            break;
                    }
                };
                app.android.on(app.AndroidApplication.activityResultEvent, onResult);
                var activity = frame.topmost().android.activity;
                var i = new android.content.Intent(activity, com.fxn.pix.Pix.class);
                i.putExtra("selection", options.imageLimit);
                activity.startActivityForResult(i, 100);
            })
                .catch(function () {
                reject("Permissions not satisfied");
            });
        });
    };
    return RadImagepicker;
}(rad_imagepicker_common_1.Common));
exports.RadImagepicker = RadImagepicker;
//# sourceMappingURL=rad-imagepicker.android.js.map